From 9204cbef6a9c20c013ac955e20d7dc24e685a5f2 Mon Sep 17 00:00:00 2001
From: Noriko Hosoi <nhosoi@redhat.com>
Date: Thu, 20 Feb 2014 13:18:53 -0800
Subject: [PATCH 2/2] Ticket #47709 - package issue in 389-ds-base

Description: Automatically generated files: Makefile.in, configure
---
 Makefile.in | 64 ++++++++++++++++++++++++++++++++++++++++++-------------------
 configure   | 42 +++++++++++++++++++++++++++++++++++++---
 2 files changed, 83 insertions(+), 23 deletions(-)

diff --git a/Makefile.in b/Makefile.in
index 780227f..1d8fa47 100644
--- a/Makefile.in
+++ b/Makefile.in
@@ -176,9 +176,9 @@ am__installdirs = "$(DESTDIR)$(serverdir)" \
 	"$(DESTDIR)$(initconfigdir)" "$(DESTDIR)$(mibdir)" \
 	"$(DESTDIR)$(propertydir)" "$(DESTDIR)$(perldir)" \
 	"$(DESTDIR)$(pkgconfigdir)" "$(DESTDIR)$(propertydir)" \
-	"$(DESTDIR)$(sampledatadir)" "$(DESTDIR)$(schemadir)" \
-	"$(DESTDIR)$(systemdsystemunitdir)" "$(DESTDIR)$(updatedir)" \
-	"$(DESTDIR)$(serverincdir)"
+	"$(DESTDIR)$(pythondir)" "$(DESTDIR)$(sampledatadir)" \
+	"$(DESTDIR)$(schemadir)" "$(DESTDIR)$(systemdsystemunitdir)" \
+	"$(DESTDIR)$(updatedir)" "$(DESTDIR)$(serverincdir)"
 LTLIBRARIES = $(server_LTLIBRARIES) $(serverplugin_LTLIBRARIES)
 am__DEPENDENCIES_1 =
 libacctpolicy_plugin_la_DEPENDENCIES = libslapd.la \
@@ -1227,8 +1227,8 @@ NROFF = nroff
 MANS = $(dist_man_MANS)
 DATA = $(config_DATA) $(inf_DATA) $(initconfig_DATA) $(mib_DATA) \
 	$(nodist_property_DATA) $(perl_DATA) $(pkgconfig_DATA) \
-	$(property_DATA) $(sampledata_DATA) $(schema_DATA) \
-	$(systemdsystemunit_DATA) $(update_DATA)
+	$(property_DATA) $(python_DATA) $(sampledata_DATA) \
+	$(schema_DATA) $(systemdsystemunit_DATA) $(update_DATA)
 HEADERS = $(serverinc_HEADERS)
 am__tagged_files = $(HEADERS) $(SOURCES) $(TAGS_FILES) \
 	$(LISP)config.h.in
@@ -1456,6 +1456,7 @@ prefix = @prefix@
 program_transform_name = @program_transform_name@
 propertydir = $(datadir)@propertydir@
 psdir = @psdir@
+pythondir = $(libdir)@pythondir@
 sampledatadir = $(datadir)@sampledatadir@
 sasl_inc = @sasl_inc@
 sasl_lib = @sasl_lib@
@@ -1664,9 +1665,7 @@ config_DATA = $(srcdir)/lib/ldaputil/certmap.conf \
 # with the default schema e.g. there is
 # considerable overlap of 60changelog.ldif and 01common.ldif
 # and 60inetmail.ldif and 50ns-mail.ldif among others
-sampledata_DATA = ldap/admin/src/scripts/failedbinds.py \
-	ldap/admin/src/scripts/DSSharedLib \
-	ldap/admin/src/scripts/logregex.py \
+sampledata_DATA = ldap/admin/src/scripts/DSSharedLib \
 	$(srcdir)/ldap/ldif/Ace.ldif \
 	$(srcdir)/ldap/ldif/European.ldif \
 	$(srcdir)/ldap/ldif/Eurosuffix.ldif \
@@ -1819,6 +1818,9 @@ perl_DATA = ldap/admin/src/scripts/SetupLog.pm \
 	ldap/admin/src/scripts/DSUpdate.pm \
 	ldap/admin/src/scripts/DSUpdateDialogs.pm
 
+python_DATA = ldap/admin/src/scripts/failedbinds.py \
+	ldap/admin/src/scripts/logregex.py
+
 property_DATA = ldap/admin/src/scripts/setup-ds.res \
 	ldap/admin/src/scripts/migrate-ds.res
 
@@ -9851,6 +9853,27 @@ uninstall-propertyDATA:
 	@list='$(property_DATA)'; test -n "$(propertydir)" || list=; \
 	files=`for p in $$list; do echo $$p; done | sed -e 's|^.*/||'`; \
 	dir='$(DESTDIR)$(propertydir)'; $(am__uninstall_files_from_dir)
+install-pythonDATA: $(python_DATA)
+	@$(NORMAL_INSTALL)
+	@list='$(python_DATA)'; test -n "$(pythondir)" || list=; \
+	if test -n "$$list"; then \
+	  echo " $(MKDIR_P) '$(DESTDIR)$(pythondir)'"; \
+	  $(MKDIR_P) "$(DESTDIR)$(pythondir)" || exit 1; \
+	fi; \
+	for p in $$list; do \
+	  if test -f "$$p"; then d=; else d="$(srcdir)/"; fi; \
+	  echo "$$d$$p"; \
+	done | $(am__base_list) | \
+	while read files; do \
+	  echo " $(INSTALL_DATA) $$files '$(DESTDIR)$(pythondir)'"; \
+	  $(INSTALL_DATA) $$files "$(DESTDIR)$(pythondir)" || exit $$?; \
+	done
+
+uninstall-pythonDATA:
+	@$(NORMAL_UNINSTALL)
+	@list='$(python_DATA)'; test -n "$(pythondir)" || list=; \
+	files=`for p in $$list; do echo $$p; done | sed -e 's|^.*/||'`; \
+	dir='$(DESTDIR)$(pythondir)'; $(am__uninstall_files_from_dir)
 install-sampledataDATA: $(sampledata_DATA)
 	@$(NORMAL_INSTALL)
 	@list='$(sampledata_DATA)'; test -n "$(sampledatadir)" || list=; \
@@ -10177,7 +10200,7 @@ check: $(BUILT_SOURCES)
 all-am: Makefile $(LIBRARIES) $(LTLIBRARIES) $(PROGRAMS) $(SCRIPTS) \
 		$(MANS) $(DATA) $(HEADERS) config.h
 installdirs:
-	for dir in "$(DESTDIR)$(serverdir)" "$(DESTDIR)$(serverplugindir)" "$(DESTDIR)$(bindir)" "$(DESTDIR)$(sbindir)" "$(DESTDIR)$(bindir)" "$(DESTDIR)$(initdir)" "$(DESTDIR)$(sbindir)" "$(DESTDIR)$(taskdir)" "$(DESTDIR)$(updatedir)" "$(DESTDIR)$(man1dir)" "$(DESTDIR)$(man8dir)" "$(DESTDIR)$(configdir)" "$(DESTDIR)$(infdir)" "$(DESTDIR)$(initconfigdir)" "$(DESTDIR)$(mibdir)" "$(DESTDIR)$(propertydir)" "$(DESTDIR)$(perldir)" "$(DESTDIR)$(pkgconfigdir)" "$(DESTDIR)$(propertydir)" "$(DESTDIR)$(sampledatadir)" "$(DESTDIR)$(schemadir)" "$(DESTDIR)$(systemdsystemunitdir)" "$(DESTDIR)$(updatedir)" "$(DESTDIR)$(serverincdir)"; do \
+	for dir in "$(DESTDIR)$(serverdir)" "$(DESTDIR)$(serverplugindir)" "$(DESTDIR)$(bindir)" "$(DESTDIR)$(sbindir)" "$(DESTDIR)$(bindir)" "$(DESTDIR)$(initdir)" "$(DESTDIR)$(sbindir)" "$(DESTDIR)$(taskdir)" "$(DESTDIR)$(updatedir)" "$(DESTDIR)$(man1dir)" "$(DESTDIR)$(man8dir)" "$(DESTDIR)$(configdir)" "$(DESTDIR)$(infdir)" "$(DESTDIR)$(initconfigdir)" "$(DESTDIR)$(mibdir)" "$(DESTDIR)$(propertydir)" "$(DESTDIR)$(perldir)" "$(DESTDIR)$(pkgconfigdir)" "$(DESTDIR)$(propertydir)" "$(DESTDIR)$(pythondir)" "$(DESTDIR)$(sampledatadir)" "$(DESTDIR)$(schemadir)" "$(DESTDIR)$(systemdsystemunitdir)" "$(DESTDIR)$(updatedir)" "$(DESTDIR)$(serverincdir)"; do \
 	  test -z "$$dir" || $(MKDIR_P) "$$dir"; \
 	done
 install: $(BUILT_SOURCES)
@@ -10336,7 +10359,7 @@ info-am:
 install-data-am: install-configDATA install-infDATA \
 	install-initSCRIPTS install-initconfigDATA install-man \
 	install-mibDATA install-nodist_propertyDATA install-perlDATA \
-	install-pkgconfigDATA install-propertyDATA \
+	install-pkgconfigDATA install-propertyDATA install-pythonDATA \
 	install-sampledataDATA install-schemaDATA \
 	install-serverLTLIBRARIES install-serverincHEADERS \
 	install-serverpluginLTLIBRARIES install-systemdsystemunitDATA \
@@ -10394,10 +10417,10 @@ uninstall-am: uninstall-binPROGRAMS uninstall-binSCRIPTS \
 	uninstall-initconfigDATA uninstall-man uninstall-mibDATA \
 	uninstall-nodist_propertyDATA uninstall-perlDATA \
 	uninstall-pkgconfigDATA uninstall-propertyDATA \
-	uninstall-sampledataDATA uninstall-sbinPROGRAMS \
-	uninstall-sbinSCRIPTS uninstall-schemaDATA \
-	uninstall-serverLTLIBRARIES uninstall-serverincHEADERS \
-	uninstall-serverpluginLTLIBRARIES \
+	uninstall-pythonDATA uninstall-sampledataDATA \
+	uninstall-sbinPROGRAMS uninstall-sbinSCRIPTS \
+	uninstall-schemaDATA uninstall-serverLTLIBRARIES \
+	uninstall-serverincHEADERS uninstall-serverpluginLTLIBRARIES \
 	uninstall-systemdsystemunitDATA uninstall-taskSCRIPTS \
 	uninstall-updateDATA uninstall-updateSCRIPTS
 
@@ -10423,8 +10446,9 @@ uninstall-man: uninstall-man1 uninstall-man8
 	install-man1 install-man8 install-mibDATA \
 	install-nodist_propertyDATA install-pdf install-pdf-am \
 	install-perlDATA install-pkgconfigDATA install-propertyDATA \
-	install-ps install-ps-am install-sampledataDATA \
-	install-sbinPROGRAMS install-sbinSCRIPTS install-schemaDATA \
+	install-ps install-ps-am install-pythonDATA \
+	install-sampledataDATA install-sbinPROGRAMS \
+	install-sbinSCRIPTS install-schemaDATA \
 	install-serverLTLIBRARIES install-serverincHEADERS \
 	install-serverpluginLTLIBRARIES install-strip \
 	install-systemdsystemunitDATA install-taskSCRIPTS \
@@ -10438,10 +10462,10 @@ uninstall-man: uninstall-man1 uninstall-man8
 	uninstall-man1 uninstall-man8 uninstall-mibDATA \
 	uninstall-nodist_propertyDATA uninstall-perlDATA \
 	uninstall-pkgconfigDATA uninstall-propertyDATA \
-	uninstall-sampledataDATA uninstall-sbinPROGRAMS \
-	uninstall-sbinSCRIPTS uninstall-schemaDATA \
-	uninstall-serverLTLIBRARIES uninstall-serverincHEADERS \
-	uninstall-serverpluginLTLIBRARIES \
+	uninstall-pythonDATA uninstall-sampledataDATA \
+	uninstall-sbinPROGRAMS uninstall-sbinSCRIPTS \
+	uninstall-schemaDATA uninstall-serverLTLIBRARIES \
+	uninstall-serverincHEADERS uninstall-serverpluginLTLIBRARIES \
 	uninstall-systemdsystemunitDATA uninstall-taskSCRIPTS \
 	uninstall-updateDATA uninstall-updateSCRIPTS
 
diff --git a/configure b/configure
index b37b5e2..da1517c 100755
--- a/configure
+++ b/configure
@@ -720,6 +720,7 @@ defaultuser
 updatedir
 mibdir
 infdir
+pythondir
 perldir
 scripttemplatedir
 serverplugindir
@@ -914,6 +915,7 @@ with_fhs
 with_fhs_opt
 with_tmpfiles_d
 with_perldir
+with_pythondir
 with_systemdsystemunitdir
 with_systemdsystemconfdir
 with_systemdgroupname
@@ -1639,6 +1641,8 @@ Optional Packages:
 
   --with-perldir=PATH     Directory for perl)
 
+  --with-pythondir=PATH   Directory for python)
+
   --with-systemdsystemunitdir=PATH
                           Directory for systemd service files (default:
                           $with_systemdsystemunitdir)
@@ -7430,7 +7434,7 @@ ia64-*-hpux*)
   rm -rf conftest*
   ;;
 
-x86_64-*kfreebsd*-gnu|x86_64-*linux*|ppc*-*linux*|powerpc*-*linux*| \
+x86_64-*kfreebsd*-gnu|x86_64-*linux*|powerpc*-*linux*| \
 s390*-*linux*|s390*-*tpf*|sparc*-*linux*)
   # Find out which ABI we are using.
   echo 'int i;' > conftest.$ac_ext
@@ -7448,7 +7452,10 @@ s390*-*linux*|s390*-*tpf*|sparc*-*linux*)
 	  x86_64-*linux*)
 	    LD="${LD-ld} -m elf_i386"
 	    ;;
-	  ppc64-*linux*|powerpc64-*linux*)
+	  powerpc64le-*linux*)
+	    LD="${LD-ld} -m elf32lppclinux"
+	    ;;
+	  powerpc64-*linux*)
 	    LD="${LD-ld} -m elf32ppclinux"
 	    ;;
 	  s390x-*linux*)
@@ -7467,7 +7474,10 @@ s390*-*linux*|s390*-*tpf*|sparc*-*linux*)
 	  x86_64-*linux*)
 	    LD="${LD-ld} -m elf_x86_64"
 	    ;;
-	  ppc*-*linux*|powerpc*-*linux*)
+	  powerpcle-*linux*)
+	    LD="${LD-ld} -m elf64lppc"
+	    ;;
+	  powerpc-*linux*)
 	    LD="${LD-ld} -m elf64ppc"
 	    ;;
 	  s390*-*linux*|s390*-*tpf*)
@@ -17988,6 +17998,8 @@ if test "$with_fhs_opt" = "yes"; then
   propertydir=/properties
   # relative to libdir
   perldir=/perl
+  # relative to libdir
+  pythondir=/python
 else
   if test "$with_fhs" = "yes"; then
     ac_default_prefix=/usr
@@ -18017,6 +18029,8 @@ else
   propertydir=/$PACKAGE_NAME/properties
   # relative to libdir
   perldir=/$PACKAGE_NAME/perl
+  # relative to libdir
+  pythondir=/$PACKAGE_NAME/python
 fi
 
 # if mandir is the default value, override it
@@ -18204,6 +18218,27 @@ else
   with_perldir=
 fi
 
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for --with-pythondir" >&5
+$as_echo_n "checking for --with-pythondir... " >&6; }
+
+# Check whether --with-pythondir was given.
+if test "${with_pythondir+set}" = set; then :
+  withval=$with_pythondir;
+fi
+
+if test -n "$with_pythondir"; then
+  if test  "$with_pythondir" = yes ; then
+    as_fn_error $? "You must specify --with-pythondir=/full/path/to/python" "$LINENO" 5
+  elif test  "$with_pythondir" = no ; then
+    with_pythondir=
+  else
+    { $as_echo "$as_me:${as_lineno-$LINENO}: result: $with_pythondir" >&5
+$as_echo "$with_pythondir" >&6; }
+  fi
+else
+  with_pythondir=
+fi
+
 { $as_echo "$as_me:${as_lineno-$LINENO}: checking for --with-systemdsystemunitdir" >&5
 $as_echo_n "checking for --with-systemdsystemunitdir... " >&6; }
 
@@ -18292,6 +18327,7 @@ fi
 
 
 
+
 # check for --with-instconfigdir
 { $as_echo "$as_me:${as_lineno-$LINENO}: checking for --with-instconfigdir" >&5
 $as_echo_n "checking for --with-instconfigdir... " >&6; }
-- 
1.8.3.1